Unit GSU2R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

function GSU2R(var ISEED :Integer): Real; 
implementation

function GSU2R(var ISEED :Integer): Real;
var
Z :Extended;
const
D2PN31 :Extended = 4.656612873077393e-10;
D2P31M :Extended = 2147483647.0e0;
D2P32M :Integer = 16807;
begin
Z := (ISEED);
Z := Emod(D2P32M*Z,D2P31M);
Result := Z*D2PN31;
ISEED := Trunc( Z );
end;

end.
