Unit ZP12C1_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure ZP12C1(var A :Array of Real; var S :Array of Real;
                N :Integer; var Z :Array of Real);

implementation

procedure ZP12C1(var A :Array of Real; var S :Array of Real;
                N :Integer; var Z :Array of Real);
var
J,J2 :Integer;
label
_1,_2;
begin
{ **********************************************************C }
{                                                           C }
{ ----------------------HAHAEHE--------------------------C }
{                                                           C }
{    BCEHE HAEH OHOMA A(T) B TOKE Z           C }
{    KOEHTOB ACTHOO OT EEH MHOOEHA A(T)      C }
{    HA OHOEH (T-Z) O CXEME OPHEPA.                    C }
{                                                           C }
{    TEPATYPA:                                            C }
{    MCOBCKX .. EK O METOAM BCEH.           C }
{    -M.:MAT,1962.                                    C }
{                                                           C }
{ ---------------------COOBAHE------------------------C }
{                                                           C }
{       CALL ZP12C1(A,S,N,Z) }
{                                                           C }
{ -----------------------APAMETP--------------------------C }
{                                                           C }
{    A - OHOMEPH MACCB H (N+1),COEPA           C }
{        KOEHT OHOMA,AAHHE O YBAH         C }
{        CTEEHE APYMEHTA (T: COMPLEX);                 C }
{                                                           C }
{    S - OHOMEPH MACCB H (N+1), OCEH           C }
{        KOMOHEHTA KOTOPOO COEPT HA BXOE HAEHE    C }
{        OHOMA A(T) B TOKE Z,A EPBE N KOMOHEHT-      C }
{        KOEHT ACTHOO OT EEH OHOMA A(T)     C }
{        HA OHOEH (T-Z) (T: COMPLEX);                  C }
{                                                           C }
{    N - CTEEH OHOMA (T: INTEGER);                   C }
{                                                           C }
{    Z - POCTA EPEMEHHA, COEPAA HAEHE APYMEHTA  C }
{        OHOMA (T: COMPLEX).                           C }
{                                                           C }
{ ----------------BBAEME OPOPAMM-------------------C }
{                                                           C }
{    HET.                                                   C }
{                                                           C }
{ -----------------------KOHCTAHT--------------------------C }
{                                                           C }
{    HET.                                                   C }
{                                                           C }
{ **********************************************************C }
S[0] := A[0];
S[1] := A[1];
if ( N = 0 ) 
 then goto _2;
for J:=1 to N do
 begin
  J2 := 2*J;
  S[J2+0] := A[J2+0]+S[J2-2]*Z[0]-S[J2-1]*Z[1];
  S[J2+1] := A[J2+1]+S[J2-2]*Z[1]+S[J2-1]*Z[0];
_1:
 end;
_2:
end;

end.
