Unit ZP12C3_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

function ZP12C3(var G :Array of Real): Real;

implementation

function ZP12C3(var G :Array of Real): Real;
var
R1,R2,R3,WMIN :Real;
const
SYS055 :Real = 1.2E-38;
label
_10,_20,_30;
begin
{ Result -    ZP12C3  FORTRANe }
{ **********************************************************C }
{                                                           C }
{ -----------------------HAHAEHE-------------------------C }
{                                                           C }
{    BCEHE MOY KOMEKCHOO CA C HOPMAAE.  C }
{                                                           C }
{    TEPATYPA:                                            C }
{    BOEBOH B.B. BCTEHE OCHOB HEHO AEP.  C }
{    -M.:HAYKA,1977.                                        C }
{                                                           C }
{ ---------------------COOBAHE------------------------C }
{                                                           C }
{        R=ZP12C3(G)                                        C }
{                                                           C }
{ -----------------------APAMETP--------------------------C }
{                                                           C }
{    G - POCTA EPEMEHHA,COEPAA AAHHOE CO       C }
{        (T: COMPLEX).                                    C }
{                                                           C }
{ ----------------BBAEME OPOPAMM-------------------C }
{                                                           C }
{             ABS,SQRT.                                     C }
{                                                           C }
{ -----------------------KOHCTAHT--------------------------C }
{                                                           C }
{    WMIN=2.715543122E-2                                    C }
{                                                           C }
{ **********************************************************C }
WMIN  := SYS055;
R1  := Abs(G[0]);
R2  := Abs(G[1]);
if ( R1  >=  R2 ) 
 then goto _10;
R3  := R1;
R1  := R2;
R2  := R3;
_10:
if ( R1  >=  WMIN ) 
 then goto _20;
Result := 0.0;
goto _30;
_20:
R3  := R1;
R1  := R2/R1;
Result := Sqrt(1.0+IntPower(R1,2))*R3;
_30:
exit;
end;

end.
