//Fortran: EQUIVALENCE ( ... )
Unit ZP12C4_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

function ZP12C4(var A :Array of Real; var B :Array of Real): Complex;

implementation

function ZP12C4(var A :Array of Real; var B :Array of Real): Complex;
var
R1,R2 :Real;
FC :Complex;
F :Array [0..1] of Real;
label
_10,_20;
begin
{ Result -    ZP12C4  FORTRANe }
{ **********************************************************C }
{                                                           C }
{ -----------------------HAHAEHE-------------------------C }
{                                                           C }
{    EEHE KOMEKCHX CE C HOPMAAE.             C }
{                                                           C }
{    TEPATYPA:                                            C }
{    BOEBOH B.B. BCTEHE OCHOB HEHO AEP.  C }
{    -M.:HAYKA,1977.                                        C }
{                                                           C }
{  --------------------COOBAHE------------------------C }
{                                                           C }
{       R=ZP12C4(A,B)                                         C }
{                                                           C }
{  ----------------------APAMETP--------------------------C }
{                                                           C }
{    A - POCTA EPEMEHHA,COEPAA EMOE              C }
{        (T: COMPLEX);                                    C }
{                                                           C }
{    B - POCTA EPEMEHHA,COEPAA ETE             C }
{        (T: COMPLEX);                                    C }
{                                                           C }
{  ---------------BBAEME OPOPAMM-------------------C }
{                                                           C }
{             ABS.                                          C }
{                                                           C }
{  ----------------------KOHCTAHT--------------------------C }
{                                                           C }
{    HET.                                                   C }
{                                                           C }
{  *********************************************************C }
if ( Abs(B[0]) >  Abs(B[1]) ) 
 then goto _10;
R1  := B[0]/B[1];
R2  := R1*B[0] + B[1];
F[0] := (R1*A[0] + A[1])/R2;
F[1] := (R1*A[1] - A[0])/R2;
goto _20;
_10:
R1  := B[1]/B[0];
R2  := R1*B[1] + B[0];
F[1] := (A[1] - R1*A[0])/R2;
F[0] := (R1*A[1] + A[0])/R2;
_20:
FC.re := F[0];  //  EQUIVALENCE
FC.im := F[1];  //  EQUIVALENCE
Result := FC;
exit;
end;

end.
