Unit ZP12C5_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTZP12_p, ZP12C3_p;

procedure ZP12C5(var A :Array of Real; var NP :Integer;
                var ROOT :Array of Real; var IERR :Integer;
                var KIER :Integer);

implementation

procedure ZP12C5(var A :Array of Real; var NP :Integer;
                var ROOT :Array of Real; var IERR :Integer;
                var KIER :Integer);
var
I,K,LN,N :Integer;
const
SYS059 :Real = 1.7E38;
label
_10,_20,_30,_40,_50,_60,_70;
begin
{ ****************************************************C }
{   OHEHE CTEEH OHOMA P HA HYEBX    C }
{   CTAPX  MAX KOEHTOB.                C }
{   IERR= - HET HYEBX CTAPX KOEHTOB        C }
{   IERR=68- CTEEH OHOMA NP MEHE 1.            C }
{   IERR=1 - ECT KIER HYEBX CTAPX KOEHTOB. C }
{ ****************************************************C }
IERR  := 0;
KIER  := 0;
if ( NP  >=  1 ) 
 then goto _10;
IERR  := 68;
UTZP12(IERR,K);
goto _70;
_10:
N  := NP;
LN  := 2*NP + 2;
_20:
if ( ZP12C3(A) <>  0.0 ) 
 then goto _40;
ROOT[LN-1] := 0.0;
ROOT[LN-2] := SYS059;
KIER  := KIER + 1;
IERR  := 1;
for I:=1 to N do
 begin
  A[2*I-2] := A[2*I+0];
  A[2*I-1] := A[2*I+1];
_30:
 end;
N  := N - 1;
LN  := LN - 2;
if ( N  >  0 ) 
 then goto _20;
ROOT[0] := ROOT[2*NP+0];
ROOT[1] := ROOT[2*NP+1];
IERR  := 1;
K  := NP - N;
UTZP12(IERR,K);
goto _60;
_40:
K  := NP - N;
if ( IERR  =  1 ) 
 then UTZP12(IERR,K);
_50:
if ( ZP12C3(A[LN-2]) >  0.0 ) 
 then goto _60;
ROOT[LN-1] := 0.0;
ROOT[LN-2] := 0.0;
LN  := LN - 2;
N  := N - 1;
if ( N  >  0 ) 
 then goto _50;
ROOT[0] := ROOT[2*NP+0];
ROOT[1] := ROOT[2*NP+1];
IERR  := 0;
_60:
NP  := N;
_70:
end;

end.
